from mod_python import apache
from albatross import ModularSessionApp, SessionAppContext
from albatross.apacheapp import Request
import popviewlib

class AppContext(SessionAppContext):
    def open_mbox(self):
        if hasattr(self.locals, 'mbox'):
            return
        self.locals.mbox = popviewlib.Mbox(self.locals.username, self.locals.passwd)

    def read_msg(self):
        if hasattr(self.locals, 'msg'):
            return
        self.locals.msg = self.locals.mbox[int(self.locals.msgnum) - 1]
        self.locals.msg.read_body()

class App(ModularSessionApp):
    def __init__(self):
        ModularSessionApp.__init__(self,
                                   base_url = 'popview5.py',
                                   module_path = '/usr/lib/cgi-bin/albtut',
                                   template_path = '/usr/lib/cgi-bin/albtut',
                                   start_page = 'login',
                                   session_appid = 'popview5')

    def create_context(self):
        return AppContext(self)

def handler(req):
    app.run(Request(req))
    return apache.OK

app = App()
